import{s as st,n as ot,o as rt}from"../chunks/scheduler.37c15a92.js";import{S as pt,i as ct,g as s,s as a,r as R,A as ht,h as o,f as i,c as l,j as lt,u as D,x as r,k as X,y as mt,a as n,v as S,d as G,t as B,w as N}from"../chunks/index.7cb9c9b8.js";import{H as J}from"../chunks/Heading.d3928e2a.js";function gt(ze){let p,Y,K,Z,g,ee,u,Ee="At this point, you might ask, “but Deep Q-Learning is excellent! Why use policy-gradient methods?“. To answer this question, let’s study the <strong>advantages and disadvantages of policy-gradient methods</strong>.",te,d,ie,f,Ue="There are multiple advantages over value-based methods. Let’s see some of them:",ne,v,ae,y,Ae="We can estimate the policy directly without storing additional data (action values).",le,w,se,x,Fe="Policy-gradient methods can <strong>learn a stochastic policy while value functions can’t</strong>.",oe,$,Ie="This has two consequences:",re,T,Qe="<li><p>We <strong>don’t need to implement an exploration/exploitation trade-off by hand</strong>. Since we output a probability distribution over actions, the agent explores <strong>the state space without always taking the same trajectory.</strong></p></li> <li><p>We also get rid of the problem of <strong>perceptual aliasing</strong>. Perceptual aliasing is when two states seem (or are) the same but need different actions.</p></li>",pe,b,We="Let’s take an example: we have an intelligent vacuum cleaner whose goal is to suck the dust and avoid killing the hamsters.",ce,c,Oe='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/hamster1.jpg" alt="Hamster 1"/>',he,C,Re="Our vacuum cleaner can only perceive where the walls are.",me,_,De="The problem is that the <strong>two red (colored) states are aliased states because the agent perceives an upper and lower wall for each</strong>.",ge,h,Se='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/hamster2.jpg" alt="Hamster 1"/>',ue,H,Ge="Under a deterministic policy, the policy will either always move right when in a red state or always move left. <strong>Either case will cause our agent to get stuck and never suck the dust</strong>.",de,L,Be="Under a value-based Reinforcement learning algorithm, we learn a <strong>quasi-deterministic policy</strong> (“greedy epsilon strategy”). Consequently, our agent can <strong>spend a lot of time before finding the dust</strong>.",fe,M,Ne="On the other hand, an optimal stochastic policy <strong>will randomly move left or right in red (colored) states</strong>. Consequently, <strong>it will not be stuck and will reach the goal state with a high probability</strong>.",ve,m,Je='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/hamster3.jpg" alt="Hamster 1"/>',ye,P,we,k,Ke="The problem with Deep Q-learning is that their <strong>predictions assign a score (maximum expected future reward) for each possible action</strong>, at each time step, given the current state.",xe,q,Ve="But what if we have an infinite possibility of actions?",$e,j,Xe="For instance, with a self-driving car, at each state, you can have a (near) infinite choice of actions (turning the wheel at 15°, 17.2°, 19,4°, honking, etc.). <strong>We’ll need to output a Q-value for each possible action</strong>! And <strong>taking the max action of a continuous output is an optimization problem itself</strong>!",Te,z,Ye="Instead, with policy-gradient methods, we output a <strong>probability distribution over actions.</strong>",be,E,Ce,U,Ze=`In value-based methods, we use an aggressive operator to <strong>change the value function: we take the maximum over Q-estimates</strong>.
Consequently, the action probabilities may change dramatically for an arbitrarily small change in the estimated action values if that change results in a different action having the maximal value.`,_e,A,et="For instance, if during the training, the best action was left (with a Q-value of 0.22) and the training step after it’s right (since the right Q-value becomes 0.23), we dramatically changed the policy since now the policy will take most of the time right instead of left.",He,F,tt="On the other hand, in policy-gradient methods, stochastic policy action preferences (probability of taking action) <strong>change smoothly over time</strong>.",Le,I,Me,Q,it="Naturally, policy-gradient methods also have some disadvantages:",Pe,W,nt="<li><strong>Frequently, policy-gradient methods converges to a local maximum instead of a global optimum.</strong></li> <li>Policy-gradient goes slower, <strong>step by step: it can take longer to train (inefficient).</strong></li> <li>Policy-gradient can have high variance. We’ll see in the actor-critic unit why, and how we can solve this problem.</li>",ke,O,at='👉 If you want to go deeper into the advantages and disadvantages of policy-gradient methods, <a href="https://youtu.be/y3oqOjHilio" rel="nofollow">you can check this video</a>.',qe,V,je;return g=new J({props:{title:"The advantages and disadvantages of policy-gradient methods",local:"the-advantages-and-disadvantages-of-policy-gradient-methods",headingTag:"h1"}}),d=new J({props:{title:"Advantages",local:"advantages",headingTag:"h2"}}),v=new J({props:{title:"The simplicity of integration",local:"the-simplicity-of-integration",headingTag:"h3"}}),w=new J({props:{title:"Policy-gradient methods can learn a stochastic policy",local:"policy-gradient-methods-can-learn-a-stochastic-policy",headingTag:"h3"}}),P=new J({props:{title:"Policy-gradient methods are more effective in high-dimensional action spaces and continuous actions spaces",local:"policy-gradient-methods-are-more-effective-in-high-dimensional-action-spaces-and-continuous-actions-spaces",headingTag:"h3"}}),E=new J({props:{title:"Policy-gradient methods have better convergence properties",local:"policy-gradient-methods-have-better-convergence-properties",headingTag:"h3"}}),I=new J({props:{title:"Disadvantages",local:"disadvantages",headingTag:"h2"}}),{c(){p=s("meta"),Y=a(),K=s("p"),Z=a(),R(g.$$.fragment),ee=a(),u=s("p"),u.innerHTML=Ee,te=a(),R(d.$$.fragment),ie=a(),f=s("p"),f.textContent=Ue,ne=a(),R(v.$$.fragment),ae=a(),y=s("p"),y.textContent=Ae,le=a(),R(w.$$.fragment),se=a(),x=s("p"),x.innerHTML=Fe,oe=a(),$=s("p"),$.textContent=Ie,re=a(),T=s("ol"),T.innerHTML=Qe,pe=a(),b=s("p"),b.textContent=We,ce=a(),c=s("figure"),c.innerHTML=Oe,he=a(),C=s("p"),C.textContent=Re,me=a(),_=s("p"),_.innerHTML=De,ge=a(),h=s("figure"),h.innerHTML=Se,ue=a(),H=s("p"),H.innerHTML=Ge,de=a(),L=s("p"),L.innerHTML=Be,fe=a(),M=s("p"),M.innerHTML=Ne,ve=a(),m=s("figure"),m.innerHTML=Je,ye=a(),R(P.$$.fragment),we=a(),k=s("p"),k.innerHTML=Ke,xe=a(),q=s("p"),q.textContent=Ve,$e=a(),j=s("p"),j.innerHTML=Xe,Te=a(),z=s("p"),z.innerHTML=Ye,be=a(),R(E.$$.fragment),Ce=a(),U=s("p"),U.innerHTML=Ze,_e=a(),A=s("p"),A.textContent=et,He=a(),F=s("p"),F.innerHTML=tt,Le=a(),R(I.$$.fragment),Me=a(),Q=s("p"),Q.textContent=it,Pe=a(),W=s("ul"),W.innerHTML=nt,ke=a(),O=s("p"),O.innerHTML=at,qe=a(),V=s("p"),this.h()},l(e){const t=ht("svelte-u9bgzb",document.head);p=o(t,"META",{name:!0,content:!0}),t.forEach(i),Y=l(e),K=o(e,"P",{}),lt(K).forEach(i),Z=l(e),D(g.$$.fragment,e),ee=l(e),u=o(e,"P",{"data-svelte-h":!0}),r(u)!=="svelte-tdbzv5"&&(u.innerHTML=Ee),te=l(e),D(d.$$.fragment,e),ie=l(e),f=o(e,"P",{"data-svelte-h":!0}),r(f)!=="svelte-maw3p6"&&(f.textContent=Ue),ne=l(e),D(v.$$.fragment,e),ae=l(e),y=o(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-2fsuyn"&&(y.textContent=Ae),le=l(e),D(w.$$.fragment,e),se=l(e),x=o(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-1e82bsg"&&(x.innerHTML=Fe),oe=l(e),$=o(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-1dwxfce"&&($.textContent=Ie),re=l(e),T=o(e,"OL",{"data-svelte-h":!0}),r(T)!=="svelte-3l8e2h"&&(T.innerHTML=Qe),pe=l(e),b=o(e,"P",{"data-svelte-h":!0}),r(b)!=="svelte-hzq0kh"&&(b.textContent=We),ce=l(e),c=o(e,"FIGURE",{class:!0,"data-svelte-h":!0}),r(c)!=="svelte-juzukv"&&(c.innerHTML=Oe),he=l(e),C=o(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-sba7bj"&&(C.textContent=Re),me=l(e),_=o(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-14k1z7"&&(_.innerHTML=De),ge=l(e),h=o(e,"FIGURE",{class:!0,"data-svelte-h":!0}),r(h)!=="svelte-zv8qjk"&&(h.innerHTML=Se),ue=l(e),H=o(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-wo6gfi"&&(H.innerHTML=Ge),de=l(e),L=o(e,"P",{"data-svelte-h":!0}),r(L)!=="svelte-h0f6wc"&&(L.innerHTML=Be),fe=l(e),M=o(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-140fl91"&&(M.innerHTML=Ne),ve=l(e),m=o(e,"FIGURE",{class:!0,"data-svelte-h":!0}),r(m)!=="svelte-y1qp89"&&(m.innerHTML=Je),ye=l(e),D(P.$$.fragment,e),we=l(e),k=o(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-1mhp325"&&(k.innerHTML=Ke),xe=l(e),q=o(e,"P",{"data-svelte-h":!0}),r(q)!=="svelte-19u4xo5"&&(q.textContent=Ve),$e=l(e),j=o(e,"P",{"data-svelte-h":!0}),r(j)!=="svelte-od3dsl"&&(j.innerHTML=Xe),Te=l(e),z=o(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-6wxwpi"&&(z.innerHTML=Ye),be=l(e),D(E.$$.fragment,e),Ce=l(e),U=o(e,"P",{"data-svelte-h":!0}),r(U)!=="svelte-1ewv4ss"&&(U.innerHTML=Ze),_e=l(e),A=o(e,"P",{"data-svelte-h":!0}),r(A)!=="svelte-xfh67p"&&(A.textContent=et),He=l(e),F=o(e,"P",{"data-svelte-h":!0}),r(F)!=="svelte-1nkvz6"&&(F.innerHTML=tt),Le=l(e),D(I.$$.fragment,e),Me=l(e),Q=o(e,"P",{"data-svelte-h":!0}),r(Q)!=="svelte-1fe6jwi"&&(Q.textContent=it),Pe=l(e),W=o(e,"UL",{"data-svelte-h":!0}),r(W)!=="svelte-posk1q"&&(W.innerHTML=nt),ke=l(e),O=o(e,"P",{"data-svelte-h":!0}),r(O)!=="svelte-s99z02"&&(O.innerHTML=at),qe=l(e),V=o(e,"P",{}),lt(V).forEach(i),this.h()},h(){X(p,"name","hf:doc:metadata"),X(p,"content",ut),X(c,"class","image table text-center m-0 w-full"),X(h,"class","image table text-center m-0 w-full"),X(m,"class","image table text-center m-0 w-full")},m(e,t){mt(document.head,p),n(e,Y,t),n(e,K,t),n(e,Z,t),S(g,e,t),n(e,ee,t),n(e,u,t),n(e,te,t),S(d,e,t),n(e,ie,t),n(e,f,t),n(e,ne,t),S(v,e,t),n(e,ae,t),n(e,y,t),n(e,le,t),S(w,e,t),n(e,se,t),n(e,x,t),n(e,oe,t),n(e,$,t),n(e,re,t),n(e,T,t),n(e,pe,t),n(e,b,t),n(e,ce,t),n(e,c,t),n(e,he,t),n(e,C,t),n(e,me,t),n(e,_,t),n(e,ge,t),n(e,h,t),n(e,ue,t),n(e,H,t),n(e,de,t),n(e,L,t),n(e,fe,t),n(e,M,t),n(e,ve,t),n(e,m,t),n(e,ye,t),S(P,e,t),n(e,we,t),n(e,k,t),n(e,xe,t),n(e,q,t),n(e,$e,t),n(e,j,t),n(e,Te,t),n(e,z,t),n(e,be,t),S(E,e,t),n(e,Ce,t),n(e,U,t),n(e,_e,t),n(e,A,t),n(e,He,t),n(e,F,t),n(e,Le,t),S(I,e,t),n(e,Me,t),n(e,Q,t),n(e,Pe,t),n(e,W,t),n(e,ke,t),n(e,O,t),n(e,qe,t),n(e,V,t),je=!0},p:ot,i(e){je||(G(g.$$.fragment,e),G(d.$$.fragment,e),G(v.$$.fragment,e),G(w.$$.fragment,e),G(P.$$.fragment,e),G(E.$$.fragment,e),G(I.$$.fragment,e),je=!0)},o(e){B(g.$$.fragment,e),B(d.$$.fragment,e),B(v.$$.fragment,e),B(w.$$.fragment,e),B(P.$$.fragment,e),B(E.$$.fragment,e),B(I.$$.fragment,e),je=!1},d(e){e&&(i(Y),i(K),i(Z),i(ee),i(u),i(te),i(ie),i(f),i(ne),i(ae),i(y),i(le),i(se),i(x),i(oe),i($),i(re),i(T),i(pe),i(b),i(ce),i(c),i(he),i(C),i(me),i(_),i(ge),i(h),i(ue),i(H),i(de),i(L),i(fe),i(M),i(ve),i(m),i(ye),i(we),i(k),i(xe),i(q),i($e),i(j),i(Te),i(z),i(be),i(Ce),i(U),i(_e),i(A),i(He),i(F),i(Le),i(Me),i(Q),i(Pe),i(W),i(ke),i(O),i(qe),i(V)),i(p),N(g,e),N(d,e),N(v,e),N(w,e),N(P,e),N(E,e),N(I,e)}}}const ut='{"title":"The advantages and disadvantages of policy-gradient methods","local":"the-advantages-and-disadvantages-of-policy-gradient-methods","sections":[{"title":"Advantages","local":"advantages","sections":[{"title":"The simplicity of integration","local":"the-simplicity-of-integration","sections":[],"depth":3},{"title":"Policy-gradient methods can learn a stochastic policy","local":"policy-gradient-methods-can-learn-a-stochastic-policy","sections":[],"depth":3},{"title":"Policy-gradient methods are more effective in high-dimensional action spaces and continuous actions spaces","local":"policy-gradient-methods-are-more-effective-in-high-dimensional-action-spaces-and-continuous-actions-spaces","sections":[],"depth":3},{"title":"Policy-gradient methods have better convergence properties","local":"policy-gradient-methods-have-better-convergence-properties","sections":[],"depth":3}],"depth":2},{"title":"Disadvantages","local":"disadvantages","sections":[],"depth":2}],"depth":1}';function dt(ze){return rt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class wt extends pt{constructor(p){super(),ct(this,p,dt,gt,st,{})}}export{wt as component};
